libstdc++: std::negative_binomial_distribution< _IntType > Class Template Reference

libstdc++

std::negative_binomial_distribution< _IntType > Class Template Reference
Numerics » Random Number Generation » Random Number Distributions » Bernoulli Distributions

`#include <random>`

## Classes
struct | param_type

## Public Types
typedef _IntType | result_type

## Public Member Functions
| negative_binomial_distribution (_IntType __k, double __p=0.5)
| negative_binomial_distribution (const param_type &__p)
template<typename _ForwardIterator, typename _UniformRandomNumberGenerator>
void | __generate (_ForwardIterator __f, _ForwardIterator __t, _UniformRandomNumberGenerator &__urng)
template<typename _ForwardIterator, typename _UniformRandomNumberGenerator>
void | __generate (_ForwardIterator __f, _ForwardIterator __t, _UniformRandomNumberGenerator &__urng, const param_type &__p)
template<typename _UniformRandomNumberGenerator>
void | __generate (result_type *__f, result_type *__t, _UniformRandomNumberGenerator &__urng)
template<typename _UniformRandomNumberGenerator>
void | __generate (result_type *__f, result_type *__t, _UniformRandomNumberGenerator &__urng, const param_type &__p)
_IntType | k () const
result_type | max () const
result_type | min () const
template<typename _UniformRandomNumberGenerator>
result_type | operator() (_UniformRandomNumberGenerator &__urng)
template<typename _UniformRandomNumberGenerator>
result_type | operator() (_UniformRandomNumberGenerator &__urng, const param_type &__p)
double | p () const
param_type | param () const
void | param (const param_type &__param)
void | reset ()

## Friends
template<typename _IntType1, typename _CharT, typename _Traits>
std::basic_ostream< _CharT, _Traits > & | operator<< (std::basic_ostream< _CharT, _Traits > &__os, const std::negative_binomial_distribution< _IntType1 > &__x)
bool | operator== (const negative_binomial_distribution &__d1, const negative_binomial_distribution &__d2)
template<typename _IntType1, typename _CharT, typename _Traits>
std::basic_istream< _CharT, _Traits > & | operator>> (std::basic_istream< _CharT, _Traits > &__is, std::negative_binomial_distribution< _IntType1 > &__x)

## Detailed Description

template<typename _IntType = int>
class std::negative_binomial_distribution< _IntType >

A negative_binomial_distribution random number distribution.

The formula for the negative binomial probability mass function is where and are the parameters of the distribution.

Since
  C++11

Definition at line 5027 of file random.h.

## Member Typedef Documentation

## ◆ result_type

template<typename _IntType = int>

typedef _IntType std::negative_binomial_distribution< _IntType >::result_type

The type of the range of the distribution.

Definition at line 5034 of file random.h.

## Constructor & Destructor Documentation

## ◆ negative_binomial_distribution() [1/3]

template<typename _IntType = int>

std::negative_binomial_distribution< _IntType >::negative_binomial_distribution | ( |  | ) |
| inline

Definition at line 5073 of file random.h.

## ◆ negative_binomial_distribution() [2/3]

template<typename _IntType = int>

std::negative_binomial_distribution< _IntType >::negative_binomial_distribution | ( | _IntType | __k,
|  | double | __p = 0.5 )
| inlineexplicit

Definition at line 5076 of file random.h.

## ◆ negative_binomial_distribution() [3/3]

template<typename _IntType = int>

std::negative_binomial_distribution< _IntType >::negative_binomial_distribution | ( | const param_type & | __p | ) |
| inlineexplicit

Definition at line 5081 of file random.h.

## Member Function Documentation

## ◆ __generate() [1/4]

template<typename _IntType = int>
template<typename _ForwardIterator, typename _UniformRandomNumberGenerator>

void std::negative_binomial_distribution< _IntType >::__generate | ( | _ForwardIterator | __f,
|  | _ForwardIterator | __t,
|  | _UniformRandomNumberGenerator & | __urng )
| inline

Definition at line 5150 of file random.h.

## ◆ __generate() [2/4]

template<typename _IntType = int>
template<typename _ForwardIterator, typename _UniformRandomNumberGenerator>

void std::negative_binomial_distribution< _IntType >::__generate | ( | _ForwardIterator | __f,
|  | _ForwardIterator | __t,
|  | _UniformRandomNumberGenerator & | __urng,
|  | const param_type & | __p )
| inline

Definition at line 5157 of file random.h.

## ◆ __generate() [3/4]

template<typename _IntType = int>
template<typename _UniformRandomNumberGenerator>

void std::negative_binomial_distribution< _IntType >::__generate | ( | result_type * | __f,
|  | result_type * | __t,
|  | _UniformRandomNumberGenerator & | __urng )
| inline

Definition at line 5164 of file random.h.

## ◆ __generate() [4/4]

template<typename _IntType = int>
template<typename _UniformRandomNumberGenerator>

void std::negative_binomial_distribution< _IntType >::__generate | ( | result_type * | __f,
|  | result_type * | __t,
|  | _UniformRandomNumberGenerator & | __urng,
|  | const param_type & | __p )
| inline

Definition at line 5170 of file random.h.

## ◆ k()

template<typename _IntType = int>

_IntType std::negative_binomial_distribution< _IntType >::k | ( |  | ) | const
| inline

Return the parameter of the distribution.

Definition at line 5096 of file random.h.

## ◆ max()

template<typename _IntType = int>

result_type std::negative_binomial_distribution< _IntType >::max | ( |  | ) | const
| inline

Returns the least upper bound value of the distribution.

Definition at line 5132 of file random.h.

## ◆ min()

template<typename _IntType = int>

result_type std::negative_binomial_distribution< _IntType >::min | ( |  | ) | const
| inline

Returns the greatest lower bound value of the distribution.

Definition at line 5125 of file random.h.

## ◆ operator()() [1/2]

template<typename _IntType>
template<typename _UniformRandomNumberGenerator>

negative_binomial_distribution< _IntType >::result_type std::negative_binomial_distribution< _IntType >::operator() | ( | _UniformRandomNumberGenerator & | __urng | ) |

Generating functions.

Definition at line 1283 of file bits/random.tcc.

## ◆ operator()() [2/2]

template<typename _IntType>
template<typename _UniformRandomNumberGenerator>

negative_binomial_distribution< _IntType >::result_type std::negative_binomial_distribution< _IntType >::operator() | ( | _UniformRandomNumberGenerator & | __urng,
|  | const param_type & | __p )

Definition at line 1296 of file bits/random.tcc.

## ◆ p()

template<typename _IntType = int>

double std::negative_binomial_distribution< _IntType >::p | ( |  | ) | const
| inline

Return the parameter of the distribution.

Definition at line 5103 of file random.h.

## ◆ param() [1/2]

template<typename _IntType = int>

param_type std::negative_binomial_distribution< _IntType >::param | ( |  | ) | const
| inline

Returns the parameter set of the distribution.

Definition at line 5110 of file random.h.

## ◆ param() [2/2]

template<typename _IntType = int>

void std::negative_binomial_distribution< _IntType >::param | ( | const param_type & | __param | ) |
| inline

Sets the parameter set of the distribution.

Parameters

  __param | The new parameter set of the distribution.

Definition at line 5118 of file random.h.

## ◆ reset()

template<typename _IntType = int>

void std::negative_binomial_distribution< _IntType >::reset | ( |  | ) |
| inline

Resets the distribution state.

Definition at line 5089 of file random.h.

## Friends And Related Symbol Documentation

## ◆ operator<<

template<typename _IntType = int>
template<typename _IntType1, typename _CharT, typename _Traits>

std::basic_ostream< _CharT, _Traits > & operator<< | ( | std::basic_ostream< _CharT, _Traits > & | __os,
|  | const std::negative_binomial_distribution< _IntType1 > & | __x )
| friend

Inserts a negative_binomial_distribution random number distribution `__x` into the output stream `__os`.

Parameters

  __os | An output stream.
  __x | A negative_binomial_distribution random number distribution.

Returns
  The output stream with the state of `__x` inserted or in an error state.

## ◆ operator==

template<typename _IntType = int>

bool operator== | ( | const negative_binomial_distribution< _IntType > & | __d1,
|  | const negative_binomial_distribution< _IntType > & | __d2 )
| friend

Return true if two negative binomial distributions have the same parameters and the sequences that would be generated are equal.

Definition at line 5181 of file random.h.

## ◆ operator>>

template<typename _IntType = int>
template<typename _IntType1, typename _CharT, typename _Traits>

std::basic_istream< _CharT, _Traits > & operator>> | ( | std::basic_istream< _CharT, _Traits > & | __is,
|  | std::negative_binomial_distribution< _IntType1 > & | __x )
| friend

Extracts a negative_binomial_distribution random number distribution `__x` from the input stream `__is`.

Parameters

  __is | An input stream.
  __x | A negative_binomial_distribution random number generator engine.

Returns
  The input stream with `__x` extracted or in an error state.

The documentation for this class was generated from the following files:

- random.h
- bits/random.tcc